#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	MAXBUF		640

int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;

	int		buff[MAXBUF];
	int		width,height;
	int		i,x,y,eqlen;
	int		a0,a1;
	int		flen;

	if (argc != 3) {
		fprintf(stderr, "Usage: pictpress infile outfile\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

/* f[^k */
/*
Ef[^͂PoCgP
Ef[^́A0x8`0xf4rbgx2i摜f[^HGRBj
E1stbit7=1ȂAf[^̂܂
E1stbit7=0,bit3=1ȂA1st2JԂi1stbit7=1ɂj
E1stbit7=0,bit3=0ȂA1st2ndJԂi1stbit7=1Abit3=1ɂj
Eŏ̂QoCǵAXTCYi/4jAYTCY
*/

	width  = fgetc(infp)*2;
	height = fgetc(infp);

	fputc(width/2,outfp);
	fputc(height,outfp);


	for (y = 0;y < height;y ++) {
		for (x = 0;x < width; x ++) {
			buff[x] = fgetc(infp);
		}
		for (x = 0;x < width;) {

		// oCǧo
			eqlen = 0;
			a0 = buff[x];
			for (i = x;i < width;i ++) {
				a1 = buff[i];
				if (a0 != a1) {
					break;
				}
				eqlen ++;
				if (eqlen >= 0xff) {
					break;
				}
			}

			if (eqlen == 2) {		// QoCgPoCgk
				a0 &= 0x7f;
				fputc(a0,outfp);
				x += 2;
			} else if (eqlen >= 3) {		// RoCgȏとQoCgk
				a0 &= 0x77;
				fputc(a0,outfp);
				fputc(eqlen,outfp);
				x += eqlen;
			} else {
				fputc(a0,outfp);
				x ++;
			}

		}
	}

	flen = ftell(outfp);
	printf("P6:%d\n",flen);

	fclose(infp);
	fclose(outfp);

	return(0);
}

